package gs.db;

//import gs.object.aUser;
import gs.db.update;
import gs.db.database;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

public class dbCourse extends database {

  public       String title;          // unique key
  public       String name;    ;

  static String tablename="courses";

  public dbCourse() {}
  public dbCourse( String title )        throws Exception
  {
    String queryString = "SELECT * from "+ getTableName() +
      " WHERE title ='"+ title +"'";
    try {
      ResultSet rs = query.queryData( queryString );
      //System.out.println("dbCourse:queryString:"+queryString);
      if( rs.next() )
	{
	  fields.put("title", (String)rs.getString("title"));
	  fields.put("oldtitle",title);
	  fields.put("name", (String)rs.getString("name"));
	  fields.put("term", (String)rs.getString("term"));
	  fields.put("year", (String)rs.getString("year"));
	  fields.put("instructor", (String)rs.getString("instructor"));
	  fields.put("insurl", (String)rs.getString("insurl")); 
	  fields.put("insemail", (String)rs.getString("insemail"));
	  fields.put("coinstructor", (String)rs.getString("coinstructor"));
	  fields.put("coinsurl", (String)rs.getString("coinsurl")); 
	  fields.put("coinsemail", (String)rs.getString("coinsemail"));
	  fields.put("ta", (String)rs.getString("ta")); 
	  fields.put("taurl", (String)rs.getString("taurl")); 
	  fields.put("taemail", (String)rs.getString("taemail")); 
	  fields.put("team", (String)rs.getString("team")); 
	  fields.put("url", (String)rs.getString("url")); 
	  fields.put("logourl", (String)rs.getString("logourl")); 
	  fields.put("grdtype", (String)rs.getString("grdtype")); 
	  fields.put("extracredits", (String)rs.getString("extracredits")); 
	  fields.put("publishavg", (String)rs.getString("publishavg")); 
	  fields.put("publishfgrd", (String)rs.getString("publishfgrd")); 
	  fields.put("notes", (String)rs.getString("notes")); 
	  setIdentification();
	} else {
	  throw new Exception("dbCourse:CourseNotFound: Course could not be found.(dbCourse)");
	}
    } catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
    setIdentification(); 
  }
  
  public void setIdentification()
  {
     this.title     = (String) fields.get("title");
     this.name    = (String)fields.get("name"); 
  }
 
  public String gradingType(){
    return (String)fields.get("grdtype");
  }

  public  String customizedGradesHtml()  throws Exception {
    String queryString = "SELECT grade,points from customizedgrades  WHERE  course='"+
      title+"' ORDER BY points";
    ResultSet rs = query.queryData( queryString );
    String grades="";
     while (rs.next())
       grades+="<option>"+(String)rs.getString("grade");
   
    return grades;
  }

  public static ResultSet listCourses( )
       throws Exception
  {
    String queryString = "SELECT DISTINCT name  FROM "+ tablename + " ORDER BY name";
    ResultSet rs = query.queryData( queryString );
    return rs;
  }

  public static Hashtable getFields(String title)  throws Exception
  {
    return new dbCourse(title).getFields(); // super class' method
  }

  public static Hashtable getEmptyFields()
       throws Exception
  {
    Hashtable result = new Hashtable();
    result.put("title",	""); 
    result.put("name",	""); 
    result.put("term",	""); 
    result.put("year",	""); 
    result.put("instructor",	""); 
    result.put("insurl",	""); 
    result.put("insemail",	""); 
    result.put("coinstructor",	""); 
    result.put("coinsurl",	""); 
    result.put("coinsemail",	""); 
    result.put("ta",	""); 
    result.put("taurl",	""); 
    result.put("taemail",	""); 
    result.put("team",	""); 
    result.put("url",	""); 
    result.put("logourl",	""); 
    result.put("grdtype",	""); 
    result.put("extracredits",	"");  
    result.put("publishavg",	""); 
    result.put("publishfgrd",	""); 
    result.put("notes",	""); 

    return result;
  }

  public String getTableName()
  {
    return tablename;
  }
  //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  // used in SQL INSERT command
  public String getFieldNames()
  {
    return "title,name,term,year,instructor,insurl,insemail,coinstructor,coinsurl,coinsemail,ta,taurl,taemail,team,url,logourl,grdtype,extracredits, publishavg,publishfgrd,notes";
  }

  // used in SQL INSERT command
  public String getFieldValues()
  {
    return                           "'"+ 
      (String)fields.get("title")	+"','"+ 
      (String)fields.get("name")	+"','"+ 
      (String)fields.get("term")	+"','"+ 
      (String)fields.get("year")	+"','"+ 
      (String)fields.get("instructor")	+"','"+ 
      (String)fields.get("insurl")	+"','"+ 
      (String)fields.get("insemail")	+"','"+ 
      (String)fields.get("coinstructor")+"','"+ 
      (String)fields.get("coinsurl")	+"','"+ 
      (String)fields.get("coinsemail")	+"','"+ 
      (String)fields.get("ta")	        +"','"+ 
      (String)fields.get("taurl")	+"','"+ 
      (String)fields.get("taemail")	+"','"+ 
      (String)fields.get("team")	+"','"+ 
      (String)fields.get("url")	        +"','"+ 
      (String)fields.get("logourl")	        +"','"+ 
      (String)fields.get("grdtype")     +"','"+  
      (String)fields.get("extracredits")+"','"+  
      (String)fields.get("publishavg")	+"','"+ 
      (String)fields.get("publishfgrd")	+"','"+ 
      (String)fields.get("notes")	
			 +"'";
  }

  //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

  // used in SQL UPDATE command
  public String getSetValues()
  {
    return "title='"          + (String)fields.get("title")
      +"',name='"              + (String)fields.get("name")
      +"',term='"              + (String)fields.get("term")
      +"',year='"              + (String)fields.get("year")
      +"',instructor='"              + (String)fields.get("instructor")
      +"',insurl='"              + (String)fields.get("insurl") 
      +"',insemail='"              + (String)fields.get("insemail")
      +"',coinstructor='"              + (String)fields.get("coinstructor")
      +"',coinsurl='"              + (String)fields.get("coinsurl") 
      +"',coinsemail='"              + (String)fields.get("coinsemail")
      +"',ta='"              + (String)fields.get("ta") 
      +"',taurl='"              + (String)fields.get("taurl") 
      +"',taemail='"              + (String)fields.get("taemail") 
      +"',team='"              + (String)fields.get("team") 
      +"',url='"              + (String)fields.get("url") 
      +"',logourl='"              + (String)fields.get("logourl") 
      +"',grdtype='"              + (String)fields.get("grdtype") 
      +"',extracredits='"              + (String)fields.get("extracredits")
      +"',publishavg='"              + (String)fields.get("publishavg")
      +"',publishfgrd='"              + (String)fields.get("publishfgrd")
      +"',notes='"              + (String)fields.get("notes") 
      +"'";
  }
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //            OPERATIONS
  // \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \

  //CONSIDER LATER
  public String updateSQL()  throws Exception {
    String oldtitle=(String)fields.get("oldtitle");
    if (!oldtitle.equals(title)) {
      String updatestr=" SET course='"+title+"' WHERE  course='"+oldtitle+"'";

      update.updateData( "UPDATE surveys "+updatestr);
      update.updateData( "UPDATE answers "+updatestr);
      update.updateData( "UPDATE students "+updatestr);
      update.updateData( "UPDATE customizedgrades "+updatestr);
      update.updateData( "UPDATE assignments "+updatestr);
      update.updateData( "UPDATE grades "+updatestr);
      update.updateData( "UPDATE performances "+updatestr);


    }
    return updateSQL("title='"+oldtitle  +"'");
  }
  public void update()throws Exception {
      update.updateData( updateSQL() );
  }

  public static void  delete(String _title) throws Exception{
    String deleteStr= "title='"+ _title +"'";
    //    String sqlcommand=new dbCourse().deleteSQL(deleteStr);
    //    update.updateData(sqlcommand );
    update.updateData( "DELETE FROM  courses WHERE "+deleteStr);
    update.updateData( "DELETE FROM answers WHERE "+deleteStr);
    update.updateData( "DELETE FROM assignments  WHERE "+deleteStr);
    update.updateData( "DELETE FROM customizedgrades WHERE "+deleteStr);
    update.updateData( "DELETE FROM grades WHERE "+deleteStr);
    update.updateData( "DELETE FROM performances WHERE "+deleteStr);
    update.updateData( "DELETE FROM questions WHERE "+deleteStr);
    update.updateData( "DELETE FROM students WHERE "+deleteStr);
    //    update.updateData( "DELETE FROM users WHERE "+deleteStr); //acl
  }
  //CONSIDER LATER
  //  public String deleteSQL() {
  //  return deleteSQL("title='"+ title +"'");
  //}

  public void add()throws Exception {

      update.updateData( insertSQL() );
  }

}







